package net.sf.l2j.gameserver.ai.special;

import net.sf.l2j.gameserver.ai.CtrlIntention;
import net.sf.l2j.gameserver.model.L2Attackable;
import net.sf.l2j.gameserver.model.L2Character;
import net.sf.l2j.gameserver.model.actor.instance.L2NpcInstance;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.model.quest.Quest;
import net.sf.l2j.gameserver.network.serverpackets.CreatureSay;
import net.sf.l2j.gameserver.util.Util;
import net.sf.l2j.util.Rnd;


public class Monastery extends Quest implements Runnable
{
	
	/*static final String[] text = {
		"You cannot carry a weapon without authorization!",
		"name, why would you choose the path of darkness?!",
		"name! How dare you defy the will of Einhasad!"
	};*/
	public Monastery(int questId, String name, String descr)
	{
		super(questId, name, descr);
		int[] mobs = {22124, 22125, 22126, 22127, 22129};
		
		for (int mob : mobs)
		{
			this.addEventId(mob, Quest.QuestEventType.ON_ATTACK);
			this.addEventId(mob, Quest.QuestEventType.ON_KILL);
			this.addEventId(mob, Quest.QuestEventType.ON_SPAWN);
			this.addEventId(mob, Quest.QuestEventType.ON_SPELL_FINISHED);
			//this.addEventId(id, Quest.QuestEventType.ON_SKILL_SEE);
			this.addEventId(mob, Quest.QuestEventType.ON_FACTION_CALL);
			this.addEventId(mob, Quest.QuestEventType.ON_AGGRO_RANGE_ENTER);			
		}
	}

	private static boolean _isAttacked = false;

	@Override
	public String onAttack (L2NpcInstance npc, L2PcInstance attacker, int damage, boolean isPet)
	{
		if (npc.getNpcId() == 22129 && _isAttacked == false && Rnd.get(100) < 30)
			npc.broadcastPacket(new CreatureSay(npc.getObjectId(), 0, npc.getName(), "Brother " + attacker.getName() + ", move your weapon away!!"));

		_isAttacked = true;

		return super.onAttack (npc, attacker, damage, isPet);
	}

	@Override
	public String onAggroRangeEnter (L2NpcInstance npc, L2PcInstance player, boolean isPet)
	{
			if (Util.calculateDistance(npc.getX(), npc.getY(), npc.getZ(), player.getX(), player.getY()) < 300)
			{
			L2Character target = isPet ? player.getPet().getOwner() : player;
			if(!((L2PcInstance) target).isGM())
				{	
				if (player.getActiveWeaponInstance() != null)
					

					{
					if (npc.getNpcId() == 22129 && Rnd.get(100) < 20)
						npc.broadcastPacket(new CreatureSay(npc.getObjectId(), 0, npc.getName(), "Brother " + target.getName() + ", move your weapon away!!"));
					else	
						npc.broadcastPacket(new CreatureSay(npc.getObjectId(), 0, npc.getName(), "You cannot carry a weapon without authorization!"));
					((L2Attackable) npc).addDamageHate(target, 0, 999);
					npc.getAI().setIntention(CtrlIntention.AI_INTENTION_ATTACK, target);
					
					}
				}
			}
		return super.onAggroRangeEnter (npc, player, isPet);
	}

	@Override
	public void run()
	{
		//new Monastery(-1, "Monastery", "ai");
	}
	

}